<template>
	<div class="p-3">
		<div class="base_block p-3 mb-3">
			<form class="dash_ftr">
				<div class="d-flex align-items-center py-2 mr-4 position-relative">
					<label style="width: 140px;" class="col-form-label">{{$store.state.locale.beginDate}}:</label>
					<datepicker
							v-model="fromDate"
							:config="options">
					</datepicker>
				</div>

				<div class="d-flex align-items-center py-2 mr-4 position-relative">
					<label style="width: 180px;" class="col-form-label">{{$store.state.locale.endDate}}:</label>
					<datepicker
							v-model="toDate"
							:config="options">
					</datepicker>
				</div>

				<div class="d-flex align-items-center py-2 mr-4 position-relative">
					<div class="custom-control custom-checkbox">
						<input v-model="isFinished" type="checkbox" class="custom-control-input" id="defaultUnchecked">
						<label class="custom-control-label" style="margin-top: 2px;" for="defaultUnchecked">Закрытые аварии</label>
					</div>
				</div>

				<div class="d-flex align-items-center py-2 mr-4">
					<div class="dash_ftr_lbl mr-2">{{ $store.state.locale.city }}:</div>
					<div class="base_select_alt dash_ftr_inp">
						<select class="form-control " v-model="cityId">
							<option :value="0">{{ $store.state.locale.all }}</option>
							<option v-for="item in cityList" :value="item.id">{{ item.name }}</option>
						</select>
						<i class="mdi mdi-menu-down"></i>
					</div>
				</div>
				<div class="d-flex align-items-center py-2 mr-4">
					<div class="dash_ftr_lbl mr-2">{{ $store.state.locale.district }}:</div>
					<div class="base_select_alt dash_ftr_inp">
						<select v-model="districtId" class="form-control " :disabled="!cityId">
							<option :value="0">{{ $store.state.locale.all }}</option>
							<option v-for="district in districtList" :value="district.id">
								{{district.name}}
							</option>
						</select>
						<i class="mdi mdi-menu-down"></i>
					</div>
				</div>
				<div class="d-flex align-items-center py-2 mr-4">
					<div class="dash_ftr_lbl mr-2">{{ $store.state.locale.street }}:</div>
					<div class="base_select_alt dash_ftr_inp">
						<select v-model="streetId" class="form-control " :disabled="!districtId">
							<option :value="0">{{ $store.state.locale.all }}</option>
							<option v-for="street in streetList" :value="street.id">{{street.name}}</option>
						</select>
						<i class="mdi mdi-menu-down"></i>
					</div>
				</div>
				<div class="d-flex align-items-center py-2 mr-4">
					<div class="dash_ftr_lbl mr-2">{{ $store.state.locale.house }}:</div>
					<div class="base_select_alt dash_ftr_inp">
						<select v-model="houseId" class="form-control" :disabled="!streetId">
							<option :value="0">{{ $store.state.locale.all }}</option>
							<option v-for="house in houseList" :value="house.id">{{house.name}}</option>
						</select>
						<i class="mdi mdi-menu-down"></i>
					</div>
				</div>
				<button @click="filter()" type="button" class="btn call_save_btn dash_ftr_btn">{{ $store.state.locale.filter }}</button>
			</form>
		</div>
		<div class="base_block p-3 mb-3">
			<div class="cplt">
				<div class="mb-5">
					<div class="cplt_table">
						<div class="cplt_table_hd mb-3">
							<h2 class="text-center">{{ $store.state.locale.crashInfo }}</h2>
						</div>
						<div class="cplt_table_bd">
							<div class="table-responsive settings_content_tb">
								<table class="table table-striped table-hover">
									<thead>
									<tr>
										<th rowspan="3">#</th>
										<th rowspan="3" colspan="1">Id</th>
										<th rowspan="3">{{$store.state.locale.serviceName}}</th>
										<th rowspan="3">{{$store.state.locale.district}}</th>
										<th rowspan="3">{{$store.state.locale.address}}</th>
										<th rowspan="3">{{$store.state.locale.description}}</th>
										<th rowspan="3">{{$store.state.locale.offReason}}</th>
										<th colspan="3">{{$store.state.locale.numObject}}</th>
										<th rowspan="3">{{$store.state.locale.offDate}}</th>
										<th rowspan="1">{{$store.state.locale.timeAndDate}}</th>
										<th rowspan="3">{{$store.state.locale.onDate}}</th>
									</tr>

									<tr>
										<th rowspan="2" >{{$store.state.locale.all}}</th>
										<th colspan="2">{{$store.state.locale.livingHouses}}</th>
										<th rowspan="2" >{{$store.state.locale.startWork}}</th>
									</tr>

									<tr>
										<th>{{$store.state.locale.own}}</th>
										<th>{{$store.state.locale.sevFloor}}</th>
									</tr>

									</thead>
									<tbody>
									<tr :style="{backgroundColor: (item.criticality === 0) ? '#fff' : (item.criticality === 1) ? 'rgba(244, 220, 66, 0.35)' : 'rgba(255, 183, 168, 0.43)' }" v-for="(item, index) in news">
										<td>{{index+1}}</td>
										<td>{{ item.id }}</td>
										<td>{{ orgList.find(x => x.id === item.organizationId) ? orgList.find(x => x.id === item.organizationId).name : '---' }}</td>
										<td>{{ districtList.find(x => x.id === item.regionId) ? districtList.find(x => x.id === item.regionId).name : '---' }}</td>
										<td>{{item.address}}</td>
										<td>{{item.description}}</td>
										<td>{{ newsType.find(x => x.id === item.newsTypeId) ? newsType.find(x => x.id === item.newsTypeId)[`name_${lang}`] : '---' }}</td>
										<td>{{item.affectedPrivateBuildings + item.affectedMultiStoryBuildings}}</td>
										<td>{{item.affectedPrivateBuildings}}</td>
										<td>{{item.affectedMultiStoryBuildings}}</td>
										<td>{{item.beginTime | formatDateSecond}}</td>
										<td>{{item.startTime | formatDateSecond}}</td>
										<td>{{item.endTime | formatDateSecond}}</td>
									</tr>
									</tbody>
								</table>
								<div class="" style="display: flex; justify-content: center; margin-top: 10px;">
									<paginate
											:page-count="pagesCount"
											v-if="pagesCount > 1"
											:click-handler="paginateData"
											container-class="pagination base_pagination"
											page-class="page-item"
											prev-class="page-item ctrl"
											next-class="page-item ctrl"
											page-link-class="page-link"
											prev-link-class="page-link"
											next-link-class="page-link"
											prev-text="<i class='mdi mdi-chevron-left'></i>"
											next-text="<i class='mdi mdi-chevron-right'></i>"
											:page-range="3"
											:margin-pages="1">
									</paginate>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
	import Paginate from 'vuejs-paginate';
	import Datepicker from "vue-bootstrap-datetimepicker";
	import 'pc-bootstrap4-datetimepicker/build/css/bootstrap-datetimepicker.css';

	export default {
		name: "crashinfo",
		components: {Paginate, Datepicker},
		data() {
			return {
				isFinished: false,
				fromDate: '',
				toDate: '',
				options: {
					format: 'YYYY-MM-DD',
					useCurrent: false,
					showClear: true,
					showClose: true,
					locale: 'ru',
					icons: {
						time: 'mdi mdi-clock-outline',
						date: 'mdi mdi-calendar',
						up: 'mdi mdi-arrow-up',
						down: 'mdi mdi-arrow-down',
						previous: 'mdi mdi-arrow-left',
						next: 'mdi mdi-arrow-right',
						today: 'mdi mdi-calendar-today',
						clear: 'mdi mdi-delete-outline',
						close: 'mdi mdi-alpha-x-circle-outline'
					}
				},

				news: [],
				cityList: [
					{
						id: 1,
						name: 'Tashkent'
					}
				],
				cityId: 0,
				districtId: 0,
				streetId: 0,
				houseId: 0,
				page: 1,
				allCount: null,
				districtList: [],
				streetList: [],
				houseList: [],
				flatList: [],
				newsType: [],
				orgList: [],

			}
		},
		created() {
			this.getAll();
		},
		mounted() {
			setTimeout(() => {
				this.getAll();
			}, 10000);
		},
		methods: {
			getAll() {
				this.$http.get('Hokimiyat/District/100000')
					.then(res => {
						if (res.data) {
							this.districtList = res.data.districts;
						}
					});
				this.$http.get('HokimiyatNews/newsTypes').then(res => {
					this.newsType = res.data.newsTypes;
				});
				this.$http.get('Admin/organization').then(res => {
					this.orgList = res.data.data;
				});

				let from, to;
				if (this.fromDate || this.toDate) {
					from = this.fromDate;
					to = this.toDate;
				} else {
					let newDate = moment(new Date()).format('YYYY-MM-DD')
					from = newDate;
					this.fromDate = newDate;
					to = newDate;
					this.toDate = newDate;
				}
				this.$http.get('/HokimiyatNews/newsFiltered' + '?cityId=' + this.cityId + '&from=' + from + '&to=' + to + '&isFinished=' + this.isFinished + '&regionId=' + this.districtId + '&streetId=' + this.streetId + '&houseId=' + this.houseId + '&page=' + this.page + '&userId=' + this.$store.state.user_id).then(res => {
					if (res.data) {
						this.news = res.data.newses;
						this.allCount = res.data.count;
					}
				});
			},
			getDistricts() {
				this.$http.get('Hokimiyat/District/100000')
					.then(res => {
						if (res.data) {
							this.districtList = res.data.districts
						}
					});
			},
			getStreets() {
				this.$http.get('Hokimiyat/Street/' + this.districtId)
					.then(res => {
						if (res.data) {
							this.streetList = res.data.streets
						}
					});
			},
			getHouses() {
				this.$http.get('Hokimiyat/House/' + this.streetId)
					.then(res => {
						if (res.data) {
							this.houseList = res.data.houses
						}
					});
			},
			filter() {
				this.getAll();
			},
			paginateData(page) {
				this.page = page;
				this.getAll();
				this.animateScrollToTop();
			},
			animateScrollToTop() {
				window.scroll({
					top: 0,
					left: 0,
					behavior: 'smooth'
				});
			},


		},
		watch: {
			cityId: function (val) {
				this.getDistricts();
				this.districtId = 0;
			},
			districtId: function (val) {
				this.getStreets();
				this.streetId = 0;
			},
			streetId: function (val) {
				this.getHouses();
				this.houseId = 0;
			},
		},
		computed: {
			pagesCount: function () {
				return Math.ceil(this.allCount / 100);
			},
			lang(){
				return this.$store.state.lang
			},
		},

	}
</script>

<style scoped>
	.filterTop {
		display: flex;
		flex-wrap: wrap;
		justify-content: center;
		padding: 16px;
		background: #fff;
		align-items: center;
	}

	.fn_header {
		position: relative;
		display: block;
		height: auto;
	}

	.fn_header_filter {
		display: flex;
		flex-wrap: wrap;
		align-items: center;
		justify-content: flex-end;
		padding: 20px 0;
	}

	.fn_header_filter > div {
		display: flex;
		flex-wrap: wrap;
		margin: 0 10px;
	}

	.fn_header_filter > div:last-child {
		margin-right: 0;
	}

	.fn_header_filter > div > select {
		width: auto;
		min-width: 150px;
		margin-left: 5px;
	}

	.backgroundColor {
		background-color: #fff;
	}

	.settings_content_tb tbody tr {
	}

	.settings_content_tb tbody tr:hover {
		border-color: #00aced;
	}
</style>